--
-- Filename: addNoteEvent.lua
-- Author: Martin Fabík (LoogleCZ)
--
-- This event is part of NotesMod.
--

addNoteEvent = {};
addNoteEvent_mt = Class(addNoteEvent, Event);

InitEventClass(addNoteEvent, "addNoteEvent");

function addNoteEvent:emptyNew()
    local self = Event:new(addNoteEvent_mt);
    return self;
end;

function addNoteEvent:new(note)
    local self = addNoteEvent:emptyNew();
	self.note = note;
    return self;
end;

function addNoteEvent:readStream(streamId, connection)
	self.note = {};
	self.note.name = streamReadString(streamId);
	self.note.content = streamReadString(streamId);
	self.note.author = streamReadString(streamId);
	self:run(connection);
end;

function addNoteEvent:writeStream(streamId, connection)
	if self.note.name == nil then
		streamWriteString(streamId, "");
	else
		streamWriteString(streamId, self.note.name);
	end;
	if self.note.content == nil then
		streamWriteString(streamId, "");
	else
		streamWriteString(streamId, self.note.content);
	end;
	streamWriteString(streamId, self.note.author);
end;

function addNoteEvent:run(connection)
	table.insert(g_currentMission.NotesBase.notes,self.note);
	if g_currentMission.NotesBase.isClient then
		Notes:drawNote(self.note);
		g_currentMission.NotesBase.itemList:checkScrollButtons();
		Notes:checkNotesCount();
	end;
	if not connection:getIsServer() then
		g_server:broadcastEvent(addNoteEvent:new(self.note));
	end;
end;

function addNoteEvent:sendEvent(name,content,author)
	local note = {};
	note.name = name;
	note.content = content;
	note.author = author;
	if g_server ~= nil then
		table.insert(g_currentMission.NotesBase.notes,note);
		if g_currentMission.NotesBase.isClient then
			Notes:drawNote(note);
			g_currentMission.NotesBase.itemList:checkScrollButtons();
			Notes:checkNotesCount();
		end;
		g_server:broadcastEvent(addNoteEvent:new(note));
	else
		g_client:getServerConnection():sendEvent(addNoteEvent:new(note));
	end;
end;
